<?php
$captcha_id = isset($_GET['id']) ? $_GET['id'] : '';

$symbols = 'AaBCDEeFfGHhKkLMmNPQRrTUVXYyZ';
$nonSymbols = '123456789';
function generate($len) {
	global $symbols;
	$str = '';
	for ($i=0; $i < $len; $i++) { 
		$str .= $symbols{rand(0, strlen($symbols)-1)};
	}
	return $str;
}

session_start();

$charh = 40;
$len = rand(4,7);
$text = generate($len);
$h = $charh*2;
$w = 20+$len*30;
$charw = ($w-20)/$len;
$_SESSION['CAPTCHA'.$captcha_id] = md5($text);

$img = imagecreatetruecolor($w, $h);
if ($img) {
	$color = imagecolorallocate($img, rand(200, 255), rand(200, 255), rand(200, 255));
	imagefill($img, 0, 0, $color);
	$colors = Array();
	for ($i = 0; $i < $len; $i++) {
		$colors[$i] = imagecolorallocate($img, rand(0, 200), rand(0, 100), rand(0, 200));
	}
	for ($i = 0; $i < $len*3; $i++) {
		$angle = rand(0, 60) - 15;
		imagettftext($img, $charh-rand(8, 20), $angle,
			rand(0, $w), rand(0, $h), $colors[rand(0, $len-1)], 'trunkset.ttf', 
			$nonSymbols{rand(0, strlen($nonSymbols)-1)});
	}
	for ($i = 0; $i < $len; $i++) {
		$angle = rand(0, 30) - 15;
		imagettftext($img, $charh, $angle, 10+$charw*$i, intval(($charh+$h)/2.3), $colors[$i], 'pointy.ttf', $text{$i});
	}
	header('Content-Type: image/jpeg');
	imagejpeg($img, NULL, 50);
	imagedestroy($img);
} else {
	echo 'Невозможно создать изображение.';
}
?>